Index: orxonox/trunk/src/gui/orxonox_gui_gtk.cc
===================================================================
--- orxonox/trunk/src/gui/orxonox_gui_gtk.cc	(revision 3422)
+++ orxonox/trunk/src/gui/orxonox_gui_gtk.cc	(revision 3423)
@@ -685,37 +1071,75 @@
    !! Options will be saved if flagname is different from NULL !!
    \param flagname the Name that will be displayed in the output
-   \param defaultvalue the default Value for this Option (see definition of defaultvalue
-*/
-void Option::setFlagName (char* flagname, int defaultvalue)
-{
-  if (flagName)
-    delete flagName;
-  flagName = new char [strlen(flagname)+1];
-  strcpy(flagName, flagname);
-  defaultValue = defaultvalue;
-
-  //  cout << "Set Flagname of " << label << " to " << flagname << endl;
+   \param defaultvalue the default Value for this Option(see definition of defaultvalue
+*/
+void Option::setFlagName(char* flagname, int defaultvalue)
+{
+  if (this->flagName)
+    delete this->flagName;
+  this->flagName = new char [strlen(flagname)+1];
+  strcpy(this->flagName, flagname);
+  this->defaultValue = defaultvalue;
+
+  //  cout << "Set Flagname of " << this->title << " to " << flagname << endl;
 }
 
 /** 
-    \brief see Option::setFlagName (char* flagname, int defaultvalue)
+    \brief see Option::setFlagName(char* flagname, int defaultvalue)
     \param flagname the Name that will be displayed in the output
-    \param defaultvalue the default Value for this Option (see definition of defaultvalue
+    \param defaultvalue the default Value for this Option(see definition of defaultvalue
     \param flagnameshort a short flagname to be displayed in the output
 */
-void Option::setFlagName (char* flagname, char* flagnameshort,  int defaultvalue)
-{
-  if (flagName)
-    delete flagName;
-  flagName = new char [strlen(flagname)+1];
-  strcpy(flagName, flagname);
-
-  if (flagNameShort)
-    delete flagNameShort;
-  flagNameShort = new char [strlen(flagnameshort)+1];
-  strcpy(flagNameShort, flagnameshort);
-  defaultValue = defaultvalue;
-  //  cout << "Set Flagname of " << label << " to " << flagname << endl;
-}
+void Option::setFlagName(char* flagname, char* flagnameshort,  int defaultvalue)
+{
+  if (this->flagName)
+    delete []this->flagName;
+  this->flagName = new char [strlen(flagname)+1];
+  strcpy(this->flagName, flagname);
+
+  if (this->flagNameShort)
+    delete []this->flagNameShort;
+  this->flagNameShort = new char [strlen(flagnameshort)+1];
+  strcpy(this->flagNameShort, flagnameshort);
+  this->defaultValue = defaultvalue;
+  //  cout << "Set Flagname of " << this->title << " to " << flagname << endl;
+}
+
+/**
+   \brief Sets the saveable-state of the option to true.
+*/
+void Option::saveability(void)
+{
+  this->saveable = true;
+}
+
+/**
+   \brief Sets the saveable-state of the option.
+   \param isSaveable the saveable-state to set.
+*/
+void Option::saveability(bool isSaveable)
+{
+  this->saveable = isSaveable;
+}
+
+/**
+   \returns The saveable-state.
+*/
+bool Option::isSaveable(void)
+{
+  return this->saveable;
+}
+
+#ifdef HAVE_GTK2
+/** 
+    \brief Signal OptionChange writes the Value from the Slider to its Object-Database.
+    \param widget The widget(Slider) that has a changed Value
+    \param slider the Slider-Object that should receive the change.
+*/
+gint Option::OptionChange(GtkWidget *widget, Widget* option)
+{
+  static_cast<Option*>(option)->changeOption();
+  flags->setTextFromFlags(Window::mainWindow);  //// must be different !!!
+}
+#endif /* HAVE_GTK2 */
 
 
@@ -733,4 +1157,12 @@
 
 /**
+   \brief destructs a Button.
+*/
+Button::~Button(void)
+{
+  this->destroy();
+}
+
+/**
    \brief Initializes a new Button
 */
@@ -742,6 +1174,19 @@
 
 #ifdef HAVE_GTK2
-  widget = gtk_button_new_with_label ("");
-#endif /* HAVE_GTK2 */
+  widget = gtk_button_new_with_label("");
+#endif /* HAVE_GTK2 */
+}
+
+/**
+   \brief Destroys a Button.
+*/
+void Button::destroy(void)
+{ 
+  if (this->title)
+    PRINTF(3)("deleting the Label: %s\n", this->title);
+  else 
+    PRINTF(3)("deleting the Label.\n");
+
+  static_cast<Option*>(this)->destroy();
 }
 
@@ -750,12 +1195,12 @@
    \param title The name the Button should get
 */
-void Button::setTitle (char *title)
-{
-  if (label)
-    delete []label;
-  label = new char[strlen(title)+1];
-  strcpy(label, title);
-#ifdef HAVE_GTK2
-  gtk_button_set_label (GTK_BUTTON(widget), title);
+void Button::setTitle(char *title)
+{
+  if (this->title)
+    delete []this->title;
+  this->title = new char[strlen(title)+1];
+  strcpy(this->title, title);
+#ifdef HAVE_GTK2
+  gtk_button_set_label(GTK_BUTTON(widget), title);
 #endif /* HAVE_GTK2 */
 }
@@ -765,6 +1210,16 @@
    not implemented yet
 */
-void Button::redraw ()
-{
+void Button::redraw(void)
+{
+}
+
+/**
+   \brief Button can not be changed, optionChange is empty)
+
+   \todo Actions for non-GTK-mode
+*/
+void Button::changeOption(void)
+{
+  // This will possibly be used for ACTIONS !
 }
 
@@ -775,5 +1230,5 @@
    \param buttonname The name the CheckButton should display.
 */
-CheckButton::CheckButton (char* buttonname)
+CheckButton::CheckButton(char* buttonname)
 {
   this->init();
@@ -781,6 +1236,14 @@
 
 #ifdef HAVE_GTK2
-  this->connectSignal ("clicked", this->OptionChange);
-#endif /* HAVE_GTK2 */
+  this->connectSignal("clicked", this->OptionChange);
+#endif /* HAVE_GTK2 */
+}
+
+/**
+   \brief destructs a CheckButton.
+*/
+CheckButton::~CheckButton(void)
+{
+  this->destroy();
 }
 
@@ -790,11 +1253,24 @@
 void CheckButton::init(void)
 {
-  isOption = 1;
+  this->isOption = 1;
 
   static_cast<Option*>(this)->init();
 
 #ifdef HAVE_GTK2
-  widget = gtk_check_button_new_with_label ("");
-#endif /* HAVE_GTK2 */
+  this->widget = gtk_check_button_new_with_label("");
+#endif /* HAVE_GTK2 */
+}
+
+/**
+   \brief Destroys a CheckButton.
+*/
+void CheckButton::destroy(void)
+{ 
+  if (this->title)
+    PRINTF(3)("deleting the CheckButton: %s\n", this->title);
+  else 
+    PRINTF(3)("deleting the CheckButton.\n");
+
+  static_cast<Option*>(this)->destroy();
 }
 
@@ -805,8 +1281,8 @@
 void CheckButton::setTitle(char* title)
 {
-  if (label)
-    delete []label;
-  label = new char[strlen(title)+1];
-  strcpy(label, title);
+  if (this->title)
+    delete []this->title;
+  this->title = new char[strlen(title)+1];
+  strcpy(this->title, title);
 #ifdef HAVE_GTK2
   gtk_button_set_label(GTK_BUTTON(widget), title);
@@ -814,5 +1290,5 @@
 }
 
-bool CheckButton::isActive()
+bool CheckButton::isActive(void)
 {
 #ifdef HAVE_GTK2
@@ -821,26 +1297,31 @@
 }
 
-#ifdef HAVE_GTK2
-/** 
-    \brief Signal OptionChange writes the Value from the CheckButton to its Object-Database.
-    \param widget The widget(CheckButton) that has a changed Value
-    \param checkbutton the CheckButton-Object that should receive the change.
-*/
-gint CheckButton::OptionChange (GtkWidget *widget, Widget* checkbutton)
-{
-  static_cast<CheckButton*>(checkbutton)->value = (int)gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON ((CheckButton*)checkbutton->widget));
-  flags->setTextFromFlags(orxonoxGUI);   ////// must be different!!!
-  cout << static_cast<CheckButton*>(checkbutton)->label << " set to: " << static_cast<CheckButton*>(checkbutton)->value << endl;
-}
-#endif /* HAVE_GTK2 */
-
-/**
-   \brief Redraws the CheckButton (if option has changed).
+/**
+   \brief Changed the Option, call this Function
+*/
+void CheckButton::changeOption(void)
+{
+#ifdef HAVE_GTK2
+  this->value =(int)gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(this->widget));
+#else /* HAVE_GTK2 */
+  char tmpChar[20];
+  cout << "\nPlease give me a new value for " << this->title << " [0,1](defualt:" << this->defaultValue << "): ";
+  cin >> tmpChar;
+
+  if ((this->value = atoi(tmpChar))=!0)
+    this->value = 1;
+#endif /* HAVE_GTK2 */
+  cout << this->title << " set to: " << this->value << endl;
+}
+
+
+/**
+   \brief Redraws the CheckButton(if option has changed).
    Example: if new settings are loaded the Button must be redrawn for the GUI to display that Change
 */
-void CheckButton::redraw ()
-{
-#ifdef HAVE_GTK2
-  gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (widget), value);
+void CheckButton::redraw(void)
+{
+#ifdef HAVE_GTK2
+  gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(this->widget), value);
 #endif /* HAVE_GTK2 */
 }
@@ -854,5 +1335,5 @@
    \param end The maximal Value of the slider.
 */
-Slider::Slider (char* slidername, int start, int end)
+Slider::Slider(char* slidername, int start, int end)
 {
   this->init(start, end);
@@ -860,21 +1341,45 @@
   this->setTitle(slidername);
 #ifdef HAVE_GTK2
-  this->connectSignal ("value_changed", this->OptionChange);
-#endif /* HAVE_GTK2 */
+  this->connectSignal("value_changed", this->OptionChange);
+#endif /* HAVE_GTK2 */
+}
+
+/**
+   \brief destructs a Slider.
+*/
+Slider::~Slider(void)
+{
+  this->destroy();
 }
 
 /**
    \brief Initializes a Slider with start and end Values
-   params: see Slider::Slider (char* slidername, int start, int end)
+   params: see Slider::Slider(char* slidername, int start, int end)
 */
 void Slider::init(int start, int end)
 {
-  isOption = 2;
+  this->isOption = 2;
 
   static_cast<Option*>(this)->init();
 
-#ifdef HAVE_GTK2
- widget = gtk_hscale_new_with_range (start, end, 5);
-#endif /* HAVE_GTK2 */
+  this->start = start;
+  this->end = end;
+#ifdef HAVE_GTK2
+ widget = gtk_hscale_new_with_range(this->start, this->end, 5);
+#endif /* HAVE_GTK2 */
+}
+
+/**
+   \brief Destroys a Slider.
+*/
+void Slider::destroy(void)
+{ 
+  if (this->title)
+    PRINTF(3)("deleting the Slider: %s\n", this->title);
+  else 
+    PRINTF(3)("deleting the Slider.\n");
+
+  static_cast<Option*>(this)->destroy();
+
 }
 
@@ -885,8 +1390,8 @@
 void Slider::setTitle(char* title)
 {
-  if (label)
-    delete []label;
-  label = new char[strlen(title)+1];
-  strcpy(label, title);
+  if (this->title)
+    delete []this->title;
+  this->title = new char[strlen(title)+1];
+  strcpy(this->title, title);
 }
 
@@ -900,27 +1405,33 @@
 }
 
-#ifdef HAVE_GTK2
-/** 
-    \brief Signal OptionChange writes the Value from the Slider to its Object-Database.
-    \param widget The widget(Slider) that has a changed Value
-    \param slider the Slider-Object that should receive the change.
-*/
-gint Slider::OptionChange (GtkWidget *widget, Widget* slider)
-{
-  static_cast<Slider*>(slider)->value = (int)gtk_range_get_value (GTK_RANGE ((Slider*)slider->widget));
-  flags->setTextFromFlags(orxonoxGUI);  //// must be different !!!
-  cout << static_cast<Slider*>(slider)->label << " set to: "<< static_cast<Slider*>(slider)->value << endl;
-}
-#endif /* HAVE_GTK2 */
-
 /**
    \brief Redraws the widget
-   Example: see void CheckButton::redraw ()
-*/
-void Slider::redraw ()
-{
-#ifdef HAVE_GTK2
-  gtk_range_set_value (GTK_RANGE (widget), value);
-#endif /* HAVE_GTK2 */
+   Example: see void CheckButton::redraw(void)
+*/
+void Slider::redraw(void)
+{
+#ifdef HAVE_GTK2
+  gtk_range_set_value(GTK_RANGE(this->widget), value);
+#endif /* HAVE_GTK2 */
+}
+
+/**
+   \brief Changed the Option, call this Function
+*/
+void Slider::changeOption(void)
+{
+#ifdef HAVE_GTK2
+  this->value =(int)gtk_range_get_value(GTK_RANGE(this->widget));
+#else /* HAVE_GTK2 */
+  char tmpChar[20];
+  cout << "\nPlease give me a new value for " << this->title << " [" <<this->start << "-" << this->end << "](defualt:" << this->defaultValue << "): ";
+  cin >> tmpChar;
+
+  if ((this->value = atoi(tmpChar))> this->end)
+    this->value = this->end;
+  if (this->value <= this->start)
+    this->value = this->start;
+#endif /* HAVE_GTK2 */
+  cout << this->title << " set to: " << this->value << endl;
 }
 
@@ -933,5 +1444,5 @@
     \param ... items to be added to this Menu. !! Consider, that the last input argument has to be "lastItem" for this to work!!
 */
-Menu::Menu (char* menuname, ...)
+Menu::Menu(char* menuname, ...)
 {
   this->init();
@@ -941,6 +1452,6 @@
 
 #ifdef HAVE_GTK2             /////////////////////// REINPLEMENT
-  va_start (itemlist, menuname);
-  while (strcmp (itemName = va_arg (itemlist, char*), "lastItem"))
+  va_start(itemlist, menuname);
+  while(strcmp(itemName = va_arg(itemlist, char*), "lastItem"))
     {
       this->addItem(itemName);
@@ -950,7 +1461,15 @@
 
 #ifdef HAVE_GTK2
-  gtk_option_menu_set_menu (GTK_OPTION_MENU (widget), menu);
-  this->connectSignal ("changed", this->OptionChange);
-#endif /* HAVE_GTK2 */
+  gtk_option_menu_set_menu(GTK_OPTION_MENU(this->widget), menu);
+  this->connectSignal("changed", this->OptionChange);
+#endif /* HAVE_GTK2 */
+}
+
+/**
+   \brief destructs a Menu.
+*/
+Menu::~Menu(void)
+{
+  this->destroy();
 }
 
@@ -960,14 +1479,29 @@
 void Menu::init(void)
 {
-  isOption = 2;
+  this->isOption = 2;
 
   static_cast<Option*>(this)->init();
 
 #ifdef HAVE_GTK2
-  widget = gtk_option_menu_new ();
-  menu = gtk_menu_new ();
-#endif /* HAVE_GTK2 */
-
-}
+  this->widget = gtk_option_menu_new();
+  this->menu = gtk_menu_new();
+#endif /* HAVE_GTK2 */
+
+}
+
+/**
+   \brief Destroys a Menu.
+*/
+void Menu::destroy(void)
+{ 
+  if (this->title)
+    PRINTF(3)("deleting the Menu: %s\n", this->title);
+  else 
+    PRINTF(3)("deleting the Menu.\n");
+  //! \todo destroy menu
+  
+  static_cast<Option*>(this)->destroy();
+}
+
 
 /**
@@ -977,8 +1511,8 @@
 void Menu::setTitle(char* title)
 {
-  if (label)
-    delete []label;
-  label = new char[strlen(title)+1];
-  strcpy(label, title);
+  if (this->title)
+    delete []this->title;
+  this->title = new char[strlen(title)+1];
+  strcpy(this->title, title);
 }
 
@@ -986,48 +1520,63 @@
    \brief appends a new Item to the Menu-List.
    \param itemName the itemName to be appendet.
-*/
-void Menu::addItem (char* itemName)
-{
-#ifdef HAVE_GTK2
-  item = gtk_menu_item_new_with_label (itemName);
-  gtk_menu_shell_append(GTK_MENU_SHELL (menu), item);
-#endif /* HAVE_GTK2 */
-}
-
-#ifdef HAVE_GTK2
-/** 
-    \brief Signal OptionChange writes the Value from the Menu to its Object-Database.
-    \param widget The widget(Menu) that has a changed Value
-    \param menu the Menu-Object that should receive the change.
-*/
-gint Menu::OptionChange (GtkWidget *widget, Widget* menu)
-{
-  static_cast<Menu*>(menu)->value = (int)gtk_option_menu_get_history (GTK_OPTION_MENU (menu->widget));
-  flags->setTextFromFlags(orxonoxGUI); //// must be different !!!
-  cout << static_cast<Menu*>(menu)->label << " changed to : " << static_cast<Menu*>(menu)->value << endl;
-}
-#endif /* HAVE_GTK2 */
+
+   \todo make the item-list readable without GTK
+*/
+void Menu::addItem(char* itemName)
+{
+#ifdef HAVE_GTK2
+  this->item = gtk_menu_item_new_with_label(itemName);
+  gtk_menu_shell_append(GTK_MENU_SHELL(this->menu), this->item);
+#endif /* HAVE_GTK2 */
+}
 
 /**
    \brief Redraws the widget
-   Example: see void CheckButton::redraw ()
-*/
-void Menu::redraw ()
-{
-#ifdef HAVE_GTK2
- gtk_option_menu_set_history (GTK_OPTION_MENU (widget), value);
-#endif /* HAVE_GTK2 */
-}
+   Example: see void CheckButton::redraw(void)
+*/
+void Menu::redraw(void)
+{
+#ifdef HAVE_GTK2
+ gtk_option_menu_set_history(GTK_OPTION_MENU(this->widget), this->value);
+#endif /* HAVE_GTK2 */
+}
+
+/**
+   \brief Changed the Option, call this Function
+*/
+void Menu::changeOption(void)
+{
+#ifdef HAVE_GTK2
+  this->value =(int)gtk_option_menu_get_history(GTK_OPTION_MENU(this->widget));
+#else /* HAVE_GTK2 */
+  char tmpChar[20];
+  cout << "\nPlease give me a new value for " << this->title << "(defualt:" << this->defaultValue << "): ";
+  cin >> tmpChar;
+  this->value = atoi(tmpChar);
+
+#endif /* HAVE_GTK2 */
+  cout << this->title << " set to: " << this->value << endl;
+}
+
+/* OPTION LABEL */
 
 /**
    \brief Creates a new OptionLabel with a LabelName and a Value.
    \param label The name of the OptionLabel.
-   \param value The Value of the OptionLabel (what will be displayed).
+   \param value The Value of the OptionLabel(what will be displayed).
 */
 OptionLabel::OptionLabel(char* label, char* value)
 {
-  init();
-  setTitle(label);
-  setValue(value);
+  this->init();
+  this->setTitle(label);
+  this->setValue(value);
+}
+
+/**
+   \brief destructs an OptionLabel.
+*/
+OptionLabel::~OptionLabel(void)
+{
+  this->destroy();
 }
 
@@ -1037,12 +1586,29 @@
 void OptionLabel::init(void)
 {
+  this->isOption = 5;
   static_cast<Option*>(this)->init();
-  isOption = 5;
+
   cValue = NULL;
 
 #ifdef HAVE_GTK2
-  widget = gtk_label_new ("");
-#endif /* HAVE_GTK2 */
-}
+  this->widget = gtk_label_new("");
+#endif /* HAVE_GTK2 */
+}
+
+/**
+   \brief Destroys a OptionLabel.
+*/
+void OptionLabel::destroy(void)
+{ 
+  if (this->title)
+    PRINTF(3)("deleting the OptionLabel: %s\n", this->title);
+  else 
+    PRINTF(3)("deleting the OptionLabel.\n");
+  if (this->cValue)
+    delete []this->cValue;
+
+  static_cast<Option*>(this)->destroy();
+}
+
 
 /**
@@ -1052,10 +1618,10 @@
 void OptionLabel::setValue(char* newValue)
 {
-  if (cValue)
-    delete cValue;
-  cValue = new char [strlen(newValue)+1];
-  strcpy(cValue, newValue);
-#ifdef HAVE_GTK2
-  gtk_label_set_text (GTK_LABEL (widget), cValue);
+  if (this->cValue)
+    delete []this->cValue;
+  this->cValue = new char [strlen(newValue)+1];
+  strcpy(this->cValue, newValue);
+#ifdef HAVE_GTK2
+  gtk_label_set_text(GTK_LABEL(this->widget), this->cValue);
 #endif /* HAVE_GTK2 */
 }
@@ -1067,20 +1633,35 @@
 void OptionLabel::setTitle(char* title)
 {
-  if (label)
-    delete []label;
-  label = new char [strlen(title)+1];
-  strcpy(label, title);
-#ifdef HAVE_GTK2
-  gtk_label_set_text (GTK_LABEL (widget), title);
-#endif /* HAVE_GTK2 */
-}
-
-/**
-   \brief Redraws an OptionLabel (not implemented yet, but it works).
+  if (this->title)
+    delete []this->title;
+  this->title = new char [strlen(title)+1];
+  strcpy(this->title, title);
+  this->redraw();
+}
+
+/**
+   \brief Redraws an OptionLabel(not implemented yet, but it works).
 */
 void OptionLabel::redraw(void)
 {
-  
-}
+#ifdef HAVE_GTK2
+  gtk_label_set_text(GTK_LABEL(widget), title);
+#endif /* HAVE_GTK2 */
+}
+
+/**
+   \brief Changed the Option, call this Function
+*/
+void OptionLabel::changeOption(void)
+{
+#ifdef HAVE_GTK2
+  this->cValue =(char*)gtk_label_get_text(GTK_LABEL(this->widget));
+#else /* HAVE_GTK2 */
+  cout << "\nPlease give me a new input for " << this->title << ": ";
+  cin >> this->cValue;
+#endif /* HAVE_GTK2 */
+  cout << this->title << " set to: " << this->cValue << endl;
+}
+
 
 /**
@@ -1088,5 +1669,5 @@
    You migth consider adding Label::setTitle with this.
 */
-Label::Label ()
+Label::Label(void)
 {
   this->init();
@@ -1097,8 +1678,16 @@
    \param text The text to be displayed.
 */
-Label:: Label (char* text)
+Label:: Label(char* text)
 {
   this->init();
-  this->setText(text);
+  this->setTitle(text);
+}
+
+/**
+   \brief destructs a Label.
+*/
+Label::~Label(void)
+{
+  this->destroy();
 }
 
@@ -1108,12 +1697,25 @@
 void Label::init(void)
 {
-  isOption = 0;
+  this->isOption = 0;
 
   static_cast<Widget*>(this)->init();
 
 #ifdef HAVE_GTK2
-  widget = gtk_label_new ("");
-  gtk_label_set_line_wrap (GTK_LABEL(widget), TRUE);
-#endif /* HAVE_GTK2 */
+  this->widget = gtk_label_new("");
+  gtk_label_set_line_wrap(GTK_LABEL(this->widget), TRUE);
+#endif /* HAVE_GTK2 */
+}
+
+/**
+   \brief Destroys a Label.
+*/
+void Label::destroy(void)
+{ 
+  if (this->title)
+    PRINTF(3)("deleting the Label: %s\n", this->title);
+  else 
+    PRINTF(3)("deleting the Label.\n");
+
+  static_cast<Widget*>(this)->destroy();
 }
 
@@ -1122,14 +1724,60 @@
    \param text The text to be inserted into the Label.
 */
-void Label::setText (char* text)
-{
-  if (label)
-    delete []label;
-  label = new char[strlen(text)+1];
-  strcpy(label, text);
-#ifdef HAVE_GTK2
-  gtk_label_set_text (GTK_LABEL (this->widget), text);
-#endif /* HAVE_GTK2 */
-}
+void Label::setTitle(char* text)
+{
+  if (this->title)
+    delete []this->title;
+  this->title = new char[strlen(text)+1];
+  strcpy(this->title, text);
+#ifdef HAVE_GTK2
+  gtk_label_set_text(GTK_LABEL(this->widget), this->title);
+#endif /* HAVE_GTK2 */
+}
+
+/**
+   \brief ereases the Text of a Label
+*/
+void Label::ereaseText(void)
+{
+  this->setTitle("");
+}
+
+/** 
+    \brief appends some Text to a Label
+    \param textToAppend The text that will be appended to this Label
+*/
+void Label::appendText(char* textToAppend)
+{
+  if (this->title)
+    {
+      char* tmpTitle = new char[strlen(this->title)+strlen(textToAppend)+1];
+      strcpy(tmpTitle, title);  
+      strcat(tmpTitle, textToAppend);
+      delete []this->title;
+      this->title = tmpTitle;
+    }
+  else
+    {
+      this->title = new char[strlen(textToAppend)];
+    }
+  
+#ifdef HAVE_GTK2
+  gtk_label_set_text(GTK_LABEL(this->widget), title);
+#endif /* HAVE_GTK2 */
+}
+
+/** 
+    \brief Appends some integer to the Label
+    \param intToAppend The Int that will be added.
+    
+    it does this by just converting the int into a char* and send it to appendText
+*/
+void Label::appendInt(int intToAppend)
+{
+  char append [32];
+  sprintf(append, "%d", intToAppend);
+  this->appendText(append);
+}
+
 
 /**
@@ -1137,6 +1785,167 @@
    \return The Text the Label holds.
 */
-char* Label::getText ()
-{
-  return label;
-}
+char* Label::getText(void)
+{
+  return this->title;
+}
+
+/**
+   \brief Creates a new ProgressBar.
+*/
+ProgressBar::ProgressBar(void)
+{
+  this->init();
+}
+
+/**
+   \brief Creates a new ProgressBar.
+   \param label The name you want to get the ProgressBar.
+*/
+ProgressBar::ProgressBar(char* label)
+{
+  this->init();
+  this->setTitle(label);
+}
+
+/**
+   \brief destructs a ProgressBar
+*/
+ProgressBar::~ProgressBar(void)
+{
+  this->destroy();
+}
+
+/**
+   \brief Initializes a ProgressBar
+*/
+void ProgressBar::init(void)
+{
+  this->isOption = 0;
+  this->progress = 0.0;
+  this->totalSize = 0.0;
+
+  static_cast<Widget*>(this)->init();
+#ifdef HAVE_GTK2
+  this->adjustment =(GtkAdjustment*)gtk_adjustment_new(0, 0, 100, 0, 0, 0);
+  this->widget = gtk_progress_bar_new_with_adjustment(this->adjustment);
+#endif /* HAVE_GTK2 */
+}
+
+/**
+   \brief Destroys a ProgressBar.
+*/
+void ProgressBar::destroy(void)
+{ 
+  if (this->title)
+    PRINTF(3)("deleting the ProgressBar: %s\n", this->title);
+  else 
+    PRINTF(3)("deleting the ProgressBar.\n");
+
+  static_cast<Widget*>(this)->destroy();
+}
+
+/**
+   \brief Sets a ned Title to the ProgressBar.
+   \param title The now title of the ProgressBar.
+*/
+void ProgressBar::setTitle(char* title)
+{
+  if (this->title)
+    delete []this->title;
+  this->title = new char [strlen(title)+1];
+  strcpy(this->title, title);
+}
+
+/**
+   \brief Sets the Total size of the Bar.(ex. The maximum one can download)
+*/
+void ProgressBar::setTotalSize(double totalSize)
+{
+  this->totalSize = totalSize;
+}
+
+/**
+   \brief Sets the progress maximum is this->totalSize
+*/
+void ProgressBar::setProgress(double progress)
+{
+  this->progress = progress;
+
+  if (this->progress > this->totalSize)
+    this->progress = this->totalSize;
+
+#ifdef HAVE_GTK2
+  gtk_progress_set_value(GTK_PROGRESS(widget), this->progress*100.0/this->totalSize);
+#endif /* HAVE_GTK2 */
+  PRINTF(3)("Progress: %f\n", this->progress*100.0/this->totalSize);
+}
+
+/**
+    \brief returns the Progress Status
+*/
+double ProgressBar::getProgress(void)
+{
+  return this->progress;
+}
+
+/* IMAGE */
+
+/**
+   \brief Creates a new Image
+   \param imagename the location of the Image on the Hard Disc
+*/
+Image::Image(char* imagename)
+{
+  this->init();
+  if (this->title)
+    delete []this->title;
+  this->title = new char[strlen(imagename)+1];
+  strcpy(this->title, imagename);
+
+#ifdef HAVE_GTK2
+  widget = gtk_image_new_from_file(imagename);
+#endif /* HAVE_GTK2 */
+}
+
+/**
+   \brief destructs an Image.
+*/
+Image::~Image(void)
+{
+  this->destroy();
+}
+
+/** 
+    \brief Initializes a new Image
+*/
+void Image::init(void)
+{
+  isOption = 0;
+
+  static_cast<Widget*>(this)->init();
+}
+
+/**
+   \brief Destroys a Image.
+*/
+void Image::destroy(void)
+{ 
+  if (this->title)
+    PRINTF(3)("deleting the Image: %s\n", this->title);
+  else 
+    PRINTF(3)("deleting the Image.\n");
+
+  static_cast<Widget*>(this)->destroy();
+}
+
+/**
+   \brief Sets a ned Title to the Image.
+   \param title The now title of the OptionLabel.
+*/
+void Image::setTitle(char* title)
+{
+  if (this->title)
+    delete []this->title;
+  this->title = new char [strlen(title)+1];
+  strcpy(this->title, title);
+}
